<template>
<div class="flex items-center no-wrap full-width">
  <div class="flex col items-center">
    <div class="flex items-center full-width">
      <q-input
        v-model="action.endpoint"
        inverted-light
        color="white"
        stack-label="Endpoint"
        class="col-grow"
      />
      <q-select
        v-model="action.method"
        inverted-light
        color="white"
        stack-label="Method"
        class="col-grow q-ml-sm"
        :options="availableMethods"
      />
    </div>
    <div class="flex items-center full-width q-mt-sm">
      <q-input
        v-model="action.description"
        inverted-light
        color="white"
        stack-label="Description"
        class="col-grow"
      />
      <q-input
        v-model="action.buttonText"
        inverted-light
        color="white"
        stack-label="Submit button text"
        class="col-grow q-ml-sm"
      />
    </div>
    <div class="flex items-center full-width q-mt-sm">
      <q-checkbox
        v-model="action.useConfirmation"
        label="With confirmation"
      />
      <q-input
        v-if="action.useConfirmation"
        v-model="action.confirmationText"
        inverted-light
        color="white"
        stack-label="Confirmation text"
        class="col-grow q-ml-sm"
      />
    </div>
  </div>
  <q-btn
    icon="build"
    round
    color="blue"
    class="q-ml-sm"
    @click="isEditingActive = true"
  />
  <action-editor
    :is-active="isEditingActive"
    :action="action"
    @close="isEditingActive = null"
  />
</div>
</template>

<script>
  import ActionEditor from './actionEditor';

  export default {
    name: 'action',
    components: { ActionEditor },
    props: {
      action: {
        type: Object,
      },
    },
    data() {
      return {
        isEditingActive: false,
        availableMethods: ['GET', 'POST', 'PUT', 'DELETE'/* , 'REST', 'OPTIONS' */]
          .map((value) => ({
            value,
            label: value,
          })),
      };
    },
    methods: {
      edit() {
        this.$emit('edit');
      },
      remove() {
        this.$emit('remove');
      },
    },
  };
</script>

<style scoped>

</style>
